           ORG    5300H
HIBYTE     EQU    0E000H
COM1       EQU    0E084H
L_COM1     EQU    COM1-HIBYTE
COM2       EQU    0E088H
L_COM2     EQU    COM2-HIBYTE
DAT1       EQU    0E086H
L_DAT1     EQU    DAT1-HIBYTE
DAT2       EQU    0E08AH
L_DAT2     EQU    DAT2-HIBYTE
BUSY1      EQU    0E085H
BUSY2      EQU    0E089H
LCDX1      EQU    22H
LCDY1      EQU    LCDX1+1
LCDX2      EQU    LCDX1+2
LCDY2      EQU    LCDX1+3
P_LO       EQU    LCDX1+4

START:     MOV    P2,#0E0H
           MOV    R0,#L_COM1
           MOV    R1,#L_COM2
           MOV    P_LO,R0
           MOV    R3,#8               ;8 lines of lcd
           MOV    LCDX1,#0B8H
           MOV    LCDY1,#40H
           MOV    LCDX2,#0B8H
           MOV    LCDY2,#40H

           MOV    A,#03FH
           MOVX   @R0,A               ;Initial page1
           MOV    DPTR,#COM2
           MOVX   @DPTR,A             ;Initial page2

           MOV    DPTR,#TAB           ;pointed to table
WR_LCD1:   MOV    P_LO,#L_COM1      ;command page1
           MOV    R0,P_LO
           MOV    A,LCDX1
           MOVX   @R0,A               ;goto x (page1)
           ACALL  GLCDBUSY
           MOV    A,LCDY1
           MOVX   @R0,A               ;goto y (page1)
           ACALL  GLCDBUSY
           MOV    P_LO,#L_DAT1
           MOV    R0,P_LO
           ACALL  WRITELN

           MOV    P_LO,#L_COM2
           MOV    R0,P_LO
           MOV    A,LCDX2
           MOVX   @R0,A               ; goto x (page2)
           ACALL  GLCDBUSY
           MOV    A,LCDY2
           MOVX   @R0,A               ; goto y (page2)
           ACALL  GLCDBUSY
           MOV    P_LO,#L_DAT2
           MOV    R0,P_LO
           ACALL  WRITELN
           INC    LCDX1
           INC    LCDX2
           DJNZ   R3,WR_LCD1

           SJMP   $

WRITELN:   MOV    R2,#64
           MOV    R1,P_LO
           DEC    R1
WR_LN1:    CLR    A                   ;clear offset
           MOVC   A,@A+DPTR           ;get data
           INC    DPTR                ;advance pointer
           MOVX   @R0,A               ;write lcd port(P2:R0)
WR_LN2:    MOVX   A,@R1
           JB     ACC.7,WR_LN2
           DJNZ   R2,WR_LN1
           RET

GLCDBUSY:  MOV    R1,P_LO
           INC    R1
GLB1:      MOVX   A,@R1
           JB     ACC.7,GLB1
           RET

TAB:       DB  0FFH,0FFH,07H,0BH,0F3H,13H,13H,13H
           DB  13H,13H,13H,13H,13H,13H,13H,13H
           DB  13H,13H,13H,13H,13H,13H,13H,13H
           DB  13H,13H,13H,13H,13H,13H,13H,13H
           DB  13H,13H,13H,13H,13H,13H,13H,13H
           DB  13H,13H,13H,13H,13H,13H,13H,13H
           DB  13H,13H,13H,13H,13H,13H,13H,13H
           DB  13H,13H,13H,13H,13H,13H,13H,13H
           DB  13H,13H,13H,13H,13H,13H,13H,13H
           DB  13H,13H,13H,13H,13H,13H,13H,13H
           DB  13H,13H,13H,13H,13H,13H,13H,13H
           DB  13H,13H,13H,0F3H,0BH,07H,0FFH,0FFH
           DB  03H,03H,03H,03H,03H,03H,03H,03H
           DB  03H,03H,43H,83H,03H,03H,03H,0E3H
           DB  03H,03H,83H,43H,03H,03H,03H,03H
           DB  03H,03H,03H,03H,03H,03H,0FFH,0FFH
LN2:       DB  0FFH,0FFH,00H,00H,0FFH,00H,00H,00H
           DB  00H,80H,60H,18H,04H,02H,01H,01H
           DB  01H,02H,04H,18H,60H,80H,00H,00H
           DB  00H,00H,00H,00H,00H,80H,60H,18H
           DB  04H,02H,01H,01H,01H,02H,04H,18H
           DB  60H,80H,00H,00H,00H,00H,00H,00H
           DB  00H,80H,60H,18H,04H,02H,01H,01H
           DB  01H,02H,04H,18H,60H,80H,00H,00H
           DB  00H,00H,00H,00H,00H,80H,60H,18H
           DB  04H,02H,01H,01H,01H,02H,04H,18H
           DB  60H,80H,00H,00H,00H,00H,00H,00H
           DB  00H,80H,60H,0FFH,00H,00H,0FFH,0FFH
           DB  00H,00H,00H,00H,00H,44H,48H,71H
           DB  1AH,0CH,04H,02H,02H,0E1H,11H,51H
           DB  11H,0E2H,02H,04H,0CH,1AH,71H,48H
           DB  44H,00H,00H,00H,00H,00H,0FFH,0FFH
LN3:       DB  0FFH,0FFH,00H,00H,0FFH,08H,08H,04H
           DB  02H,01H,80H,00H,00H,00H,00H,00H
           DB  00H,00H,00H,00H,80H,01H,02H,04H
           DB  08H,08H,08H,04H,02H,01H,80H,00H
           DB  00H,00H,00H,00H,00H,00H,00H,00H
           DB  80H,01H,02H,04H,08H,08H,08H,04H
           DB  02H,01H,80H,00H,00H,00H,00H,00H
           DB  00H,00H,00H,00H,80H,01H,02H,04H
           DB  08H,08H,08H,04H,02H,01H,80H,00H
           DB  00H,00H,00H,00H,00H,00H,00H,00H
           DB  80H,01H,02H,04H,08H,08H,08H,04H
           DB  02H,01H,80H,0FFH,00H,00H,0FFH,0FFH
           DB  00H,00H,00H,00H,00H,00H,00H,40H
           DB  80H,00H,10H,0A0H,80H,40H,41H,79H
           DB  41H,80H,0A0H,10H,00H,80H,40H,00H
           DB  00H,00H,00H,00H,00H,00H,0FFH,0FFH
LN4:       DB  0FFH,0FFH,00H,00H,0FFH,01H,01H,01H
           DB  01H,01H,0E3H,21H,21H,21H,21H,21H
           DB  21H,21H,21H,21H,0E3H,01H,01H,01H
           DB  01H,01H,01H,01H,01H,01H,0E3H,21H
           DB  21H,21H,21H,21H,21H,21H,21H,21H
           DB  0E3H,01H,01H,01H,01H,01H,01H,01H
           DB  01H,01H,0E3H,21H,21H,21H,21H,21H
           DB  21H,21H,21H,21H,0E3H,01H,01H,01H
           DB  01H,01H,01H,01H,01H,01H,0E3H,21H
           DB  21H,21H,21H,21H,21H,21H,21H,21H
           DB  0E3H,01H,01H,01H,01H,01H,01H,01H
           DB  01H,01H,0E3H,0FFH,00H,00H,0FFH,0FFH
           DB  00H,00H,00H,00H,00H,11H,12H,1CH
           DB  06H,03H,01H,00H,00H,38H,44H,54H
           DB  44H,38H,00H,01H,03H,06H,1CH,12H
           DB  11H,00H,00H,00H,00H,00H,0FFH,0FFH
LN5:       DB  0FFH,0FFH,00H,00H,0FFH,08H,08H,08H
           DB  08H,08H,0FH,00H,00H,00H,00H,00H
           DB  00H,00H,00H,00H,0FH,08H,08H,08H
           DB  08H,08H,08H,08H,08H,08H,0FH,00H
           DB  00H,00H,00H,00H,00H,00H,00H,00H
           DB  0FH,08H,08H,08H,08H,08H,08H,08H
           DB  08H,08H,0FH,00H,00H,00H,00H,00H
           DB  00H,00H,00H,00H,0FH,08H,08H,08H
           DB  08H,08H,08H,08H,08H,08H,0FH,00H
           DB  00H,00H,00H,00H,00H,00H,00H,00H
           DB  0FH,08H,08H,08H,08H,08H,08H,08H
           DB  08H,08H,0FH,0FFH,00H,00H,0FFH,0FFH
           DB  00H,00H,00H,00H,00H,70H,88H,0A8H
           DB  88H,70H,00H,00H,00H,00H,00H,00H
           DB  00H,00H,00H,00H,70H,88H,0A8H,88H
           DB  70H,00H,00H,00H,00H,00H,0FFH,0FFH
LN6:       DB  0FFH,0FFH,38H,34H,33H,32H,32H,32H
           DB  32H,32H,32H,32H,32H,32H,32H,32H
           DB  32H,32H,32H,32H,32H,32H,32H,32H
           DB  32H,32H,32H,32H,32H,32H,32H,32H
           DB  32H,32H,32H,32H,32H,32H,32H,32H
           DB  32H,32H,32H,32H,32H,32H,32H,32H
           DB  32H,32H,32H,32H,32H,32H,32H,32H
           DB  32H,32H,32H,32H,32H,32H,32H,32H
           DB  32H,32H,32H,32H,32H,32H,32H,32H
           DB  32H,32H,32H,32H,32H,32H,32H,32H
           DB  32H,32H,32H,32H,32H,32H,32H,0F2H
           DB  0F2H,32H,32H,33H,34H,38H,3FH,3FH
           DB  30H,30H,30H,30H,30H,30H,30H,30H
           DB  30H,30H,30H,30H,30H,30H,30H,30H
           DB  30H,30H,30H,30H,30H,30H,30H,30H
           DB  30H,30H,30H,30H,30H,30H,0FFH,0FFH
LN7:       DB  0FFH,0FFH,00H,00H,00H,00H,00H,40H
           DB  20H,20H,20H,0C0H,00H,40H,20H,20H
           DB  20H,0C0H,00H,40H,20H,0A0H,30H,2AH
           DB  0C6H,00H,48H,0ACH,4AH,22H,0C4H,48H
           DB  0A0H,14H,0CH,40H,20H,0A0H,20H,24H
           DB  0C6H,06H,0AH,0F2H,02H,04H,44H,24H
           DB  0A0H,20H,20H,0C0H,00H,40H,20H,0A0H
           DB  30H,2AH,0C6H,00H,04H,06H,06H,0AH
           DB  0F2H,02H,04H,0C4H,24H,0A0H,0A0H,20H
           DB  0C0H,00H,00H,40H,20H,0C0H,00H,00H
           DB  0FCH,00H,00H,00H,00H,00H,00H,0FFH
           DB  0FFH,00H,00H,00H,00H,00H,00H,0E0H
           DB  10H,0C8H,0E8H,0E8H,0C8H,10H,0E0H,00H
           DB  00H,00H,00H,00H,00H,00H,00H,00H
           DB  0E0H,10H,0C8H,0E8H,0E8H,0C8H,10H,0E0H
           DB  00H,00H,00H,00H,00H,00H,0FFH,0FFH
LN8:       DB  0FFH,0FFH,0C0H,0C0H,0C0H,0C0H,0C0H,0C3H
           DB  0C5H,0C4H,0C4H,0C3H,0C0H,0C3H,0C5H,0C4H
           DB  0C4H,0C3H,0C0H,0C0H,0C3H,0C4H,0C1H,0C2H
           DB  0C7H,0C0H,0C0H,0C0H,0C0H,0C3H,0C4H,0C4H
           DB  0C3H,0C0H,0C0H,0C0H,0C3H,0C4H,0C1H,0C2H
           DB  0C7H,0C0H,0C0H,0C3H,0C4H,0C0H,0C0H,0C3H
           DB  0C4H,0C1H,0C2H,0C7H,0C0H,0C0H,0C3H,0C4H
           DB  0C1H,0C2H,0C7H,0C0H,0C0H,0C0H,0C0H,0C0H
           DB  0C3H,0C4H,0C0H,0C7H,0C1H,0C0H,0C0H,0C0H
           DB  0C7H,0C0H,0C0H,0C2H,0C5H,0C4H,0C4H,0C4H
           DB  0C3H,0C0H,0C0H,0C0H,0C0H,0C0H,0C0H,0FFH
           DB  0FFH,0C0H,0C0H,0C0H,0C0H,0C0H,0C0H,0C1H
           DB  0C2H,0C4H,0C5H,0C5H,0C4H,0C2H,0C1H,0C0H
           DB  0C0H,0C0H,0C0H,0C0H,0C0H,0C0H,0C0H,0C0H
           DB  0C1H,0C2H,0C4H,0C5H,0C5H,0C4H,0C2H,0C1H
           DB  0C0H,0C0H,0C0H,0C0H,0C0H,0C0H,0FFH,0FFH

          END




